var downloadyoutubevideosasmp_gmCompiler={

// getUrlContents adapted from Greasemonkey Compiler
// http://www.letitblog.com/code/python/greasemonkey.py.txt
// used under GPL permission
//
// most everything else below based heavily off of Greasemonkey
// http://greasemonkey.mozdev.org/
// used under GPL permission

getUrlContents: function(aUrl){
	var	ioService=Components.classes["@mozilla.org/network/io-service;1"]
		.getService(Components.interfaces.nsIIOService);
	var	scriptableStream=Components
		.classes["@mozilla.org/scriptableinputstream;1"]
		.getService(Components.interfaces.nsIScriptableInputStream);

	var	channel=ioService.newChannel(aUrl, null, null);
	var	input=channel.open();
	scriptableStream.init(input);
	var	str=scriptableStream.read(input.available());
	scriptableStream.close();
	input.close();

	return str;
},

isGreasemonkeyable: function(url) {
	var scheme=Components.classes["@mozilla.org/network/io-service;1"]
		.getService(Components.interfaces.nsIIOService)
		.extractScheme(url);
	return (
		(scheme == "http" || scheme == "https" || scheme == "file") &&
		!/hiddenWindow\.html$/.test(url)
	);
},

contentLoad: function(e) {
	var unsafeWin=e.target.defaultView;
	if (unsafeWin.wrappedJSObject) unsafeWin=unsafeWin.wrappedJSObject;

	var unsafeLoc=new XPCNativeWrapper(unsafeWin, "location").location;
	var href=new XPCNativeWrapper(unsafeLoc, "href").href;

	if (
		downloadyoutubevideosasmp_gmCompiler.isGreasemonkeyable(href)
		&& ( /http:\/\/.*\.youtube\.com\/watch\?.*/.test(href) || /http:\/\/youtube\.com\/watch\?.*/.test(href) )
		&& true
	) {
		var script=downloadyoutubevideosasmp_gmCompiler.getUrlContents(
			'chrome://downloadyoutubevideosasmp/content/downloadyoutubevideosasmp.js'
		);
		downloadyoutubevideosasmp_gmCompiler.injectScript(script, href, unsafeWin);
	}
},

injectScript: function(script, url, unsafeContentWin) {
	var sandbox, script, logger, storage, xmlhttpRequester;
	var safeWin=new XPCNativeWrapper(unsafeContentWin);

	sandbox=new Components.utils.Sandbox(safeWin);

	var storage=new downloadyoutubevideosasmp_ScriptStorage();
	xmlhttpRequester=new downloadyoutubevideosasmp_xmlhttpRequester(
		unsafeContentWin, window//appSvc.hiddenDOMWindow
	);

	sandbox.window=safeWin;
	sandbox.document=sandbox.window.document;
	sandbox.unsafeWindow=unsafeContentWin;

	// patch missing properties on xpcnw
	sandbox.XPathResult=Components.interfaces.nsIDOMXPathResult;

	// add our own APIs
	sandbox.GM_addStyle=function(css) { downloadyoutubevideosasmp_gmCompiler.addStyle(sandbox.document, css) };
	sandbox.GM_setValue=downloadyoutubevideosasmp_gmCompiler.hitch(storage, "setValue");
	sandbox.GM_getValue=downloadyoutubevideosasmp_gmCompiler.hitch(storage, "getValue");
	sandbox.GM_openInTab=downloadyoutubevideosasmp_gmCompiler.hitch(this, "openInTab", unsafeContentWin);
	sandbox.GM_xmlhttpRequest=downloadyoutubevideosasmp_gmCompiler.hitch(
		xmlhttpRequester, "contentStartRequest"
	);
	//unsupported
	sandbox.GM_registerMenuCommand=function(){};
	sandbox.GM_log=function(){};
	sandbox.GM_getResourceURL=function(){};
	sandbox.GM_getResourceText=function(){};

	sandbox.__proto__=sandbox.window;

	try {
		this.evalInSandbox(
			"(function(){"+script+"})()",
			url,
			sandbox);
	} catch (e) {
		var e2=new Error(typeof e=="string" ? e : e.message);
		e2.fileName=script.filename;
		e2.lineNumber=0;
		//GM_logError(e2);
		alert(e2);
	}
},

evalInSandbox: function(code, codebase, sandbox) {
	if (Components.utils && Components.utils.Sandbox) {
		// DP beta+
		Components.utils.evalInSandbox(code, sandbox);
	} else if (Components.utils && Components.utils.evalInSandbox) {
		// DP alphas
		Components.utils.evalInSandbox(code, codebase, sandbox);
	} else if (Sandbox) {
		// 1.0.x
		evalInSandbox(code, sandbox, codebase);
	} else {
		throw new Error("Could not create sandbox.");
	}
},

openInTab: function(unsafeContentWin, url) {
	var tabBrowser = getBrowser(), browser, isMyWindow = false;
	for (var i = 0; browser = tabBrowser.browsers[i]; i++)
		if (browser.contentWindow == unsafeContentWin) {
			isMyWindow = true;
			break;
		}
	if (!isMyWindow) return;
 
	var loadInBackground, sendReferrer, referrer = null;
	loadInBackground = tabBrowser.mPrefs.getBoolPref("browser.tabs.loadInBackground");
	sendReferrer = tabBrowser.mPrefs.getIntPref("network.http.sendRefererHeader");
	if (sendReferrer) {
		var ios = Components.classes["@mozilla.org/network/io-service;1"]
							.getService(Components.interfaces.nsIIOService);
		referrer = ios.newURI(content.document.location.href, null, null);
	 }
	 tabBrowser.loadOneTab(url, referrer, null, null, loadInBackground);
 },
 
 hitch: function(obj, meth) {
	var unsafeTop = new XPCNativeWrapper(unsafeContentWin, "top").top;

	for (var i = 0; i < this.browserWindows.length; i++) {
		this.browserWindows[i].openInTab(unsafeTop, url);
	}
},

apiLeakCheck: function(allowedCaller) {
	var stack=Components.stack;

	var leaked=false;
	do {
		if (2==stack.language) {
			if ('chrome'!=stack.filename.substr(0, 6) &&
				allowedCaller!=stack.filename 
			) {
				leaked=true;
				break;
			}
		}

		stack=stack.caller;
	} while (stack);

	return leaked;
},

hitch: function(obj, meth) {
	if (!obj[meth]) {
		throw "method '" + meth + "' does not exist on object '" + obj + "'";
	}

	var hitchCaller=Components.stack.caller.filename;
	var staticArgs = Array.prototype.splice.call(arguments, 2, arguments.length);

	return function() {
		if (downloadyoutubevideosasmp_gmCompiler.apiLeakCheck(hitchCaller)) {
			return;
		}
		
		// make a copy of staticArgs (don't modify it because it gets reused for
		// every invocation).
		var args = staticArgs.concat();

		// add all the new arguments
		for (var i = 0; i < arguments.length; i++) {
			args.push(arguments[i]);
		}

		// invoke the original function with the correct this obj and the combined
		// list of static and dynamic arguments.
		return obj[meth].apply(obj, args);
	};
},

addStyle:function(doc, css) {
	var head, style;
	head = doc.getElementsByTagName('head')[0];
	if (!head) { return; }
	style = doc.createElement('style');
	style.type = 'text/css';
	style.innerHTML = css;
	head.appendChild(style);
},

onLoad: function() {
	var	appcontent=window.document.getElementById("appcontent");
	if (appcontent && !appcontent.greased_downloadyoutubevideosasmp_gmCompiler) {
		appcontent.greased_downloadyoutubevideosasmp_gmCompiler=true;
		appcontent.addEventListener("DOMContentLoaded", downloadyoutubevideosasmp_gmCompiler.contentLoad, false);
	}
},

onUnLoad: function() {
	//remove now unnecessary listeners
	window.removeEventListener('load', downloadyoutubevideosasmp_gmCompiler.onLoad, false);
	window.removeEventListener('unload', downloadyoutubevideosasmp_gmCompiler.onUnLoad, false);
	window.document.getElementById("appcontent")
		.removeEventListener("DOMContentLoaded", downloadyoutubevideosasmp_gmCompiler.contentLoad, false);
},

}; //object downloadyoutubevideosasmp_gmCompiler


function downloadyoutubevideosasmp_ScriptStorage() {
	this.prefMan=new downloadyoutubevideosasmp_PrefManager();
}
downloadyoutubevideosasmp_ScriptStorage.prototype.setValue = function(name, val) {
	this.prefMan.setValue(name, val);
}
downloadyoutubevideosasmp_ScriptStorage.prototype.getValue = function(name, defVal) {
	return this.prefMan.getValue(name, defVal);
}


window.addEventListener('load', downloadyoutubevideosasmp_gmCompiler.onLoad, false);
window.addEventListener('unload', downloadyoutubevideosasmp_gmCompiler.onUnLoad, false);

var Prefs = Components.classes["@mozilla.org/preferences-service;1"]
                   .getService(Components.interfaces.nsIPrefService);
Prefs = Prefs.getBranch("extensions.my_extension_name.");


var Overlay = {
  init: function(){
    var ver = -1, firstrun = true;

    var gExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"]
                            .getService(Components.interfaces.nsIExtensionManager);
    var current = gExtensionManager.getItemForID("{c0c9a2c7-2e5c-4447-bc53-97718bc91e1b}").version;
    //gets the version number.
    //"extension@guid.net" should be replaced with your extension's GUID.
	
//Check non-compatible Extensions
//... Flashblock - {3d7eb24f-2740-49df-8937-200b1cc08f8a} ...  //  	
//... NoScript - {73a6fe31-595d-460b-a920-fcc0f8843232}... //  	
//var myExtensionID = "{3d7eb24f-2740-49df-8937-200b1cc08f8a}";
//var isExtEnabled = Application.extensions.get(myExtensionID) ;
//Application.console.log('Is Flashblock Enabled ' + isExtEnabled.enabled);
//Application.console.log('Does Flashblock still exist ' + Application.extensions.has(myExtensionID));
//if (isExtEnabled.enabled) {

// instruct user to add youtube.com to whitelist

//}

//var myExtensionID = "{73a6fe31-595d-460b-a920-fcc0f8843232}";
//var isExtEnabled = Application.extensions.get(myExtensionID) ;
//Application.console.log('Is NoScript Enabled ' + isExtEnabled.enabled);
//Application.console.log('Does NoScript still exist ' + Application.extensions.has(myExtensionID));
	
    try{
	ver = Prefs.getCharPref("version");
	firstrun = Prefs.getBoolPref("firstrun");
    }catch(e){
      //nothing
    }finally{
      if (firstrun){
        Prefs.setBoolPref("firstrun",false);
        Prefs.setCharPref("version",current);
	
        // Insert code for first run here        

        // The example below loads a page by opening a new tab.
        // Useful for loading a mini tutorial
        window.setTimeout(function(){
          gBrowser.selectedTab = gBrowser.addTab("http://www.free-video-downloader.com/install-success.html");
        }, 1500); //Firefox 2 fix - or else tab will get closed
		
		//Open Save Preference Dialog on first launch
		//window.openDialog("chrome://downloadyoutubevideosasmp/content/options.xul","dlgeasyyoutubevddl","chrome, dialog, modal, resizable=yes,centerscreen").focus();

      }		
      
      if (ver!=current && !firstrun){ // !firstrun ensures that this section does not get loaded if its a first run.
        Prefs.setCharPref("version",current);
        
        // Insert code if version is different here => upgrade
		window.setTimeout(function(){
          gBrowser.selectedTab = gBrowser.addTab("http://www.free-video-downloader.com/update-success.html");
        }, 1500); //Firefox 2 fix - or else tab will get closed		
		
		//Open Save Preference Dialog on update
		//window.openDialog("chrome://downloadyoutubevideosasmp/content/options.xul","dlgeasyyoutubevddl","chrome, dialog, modal, resizable=yes,centerscreen").focus();
		
      }
    }
    window.removeEventListener("load",function(){ Overlay.init(); },true);
  }
};


window.addEventListener("load",function(){ Overlay.init(); },true);



function myLinkListener(e) {

//Retrieve Video Name
var vtitle = document.title.split('YouTube - ')[1].split(' - Mozilla')[0];
// Clean out illegal filename chracters
//vtitle =  vtitle.replace(/[^a-zA-Z 0-9]+/g,'');
illchr = /\$|,|@|#|~|`|\%|\*|\^|\&|\(|\)|\+|\=|\_|\}|\{|\;|\:|\'|\"|\<|\>|\?|\||\\|\!|\$|\./g;
// remove special characters like "$" and "," etc...
vtitle = vtitle.replace(illchr, "");
vtitle = vtitle.replace(/\//g, "");

 //alert(e.target.href + vtitle); // e.target should be the link
 //alert(e.target.text); - Get File-extension Type


//Access Save Location
var savedir = "";
var prefManager = Components.classes["@mozilla.org/preferences-service;1"]
         .getService(Components.interfaces.nsIPrefService)
         .getBranch("extensions.downloadyoutubevideosasmp.");
   var prefString;
   if (prefManager.prefHasUserValue("savelocation")) {
		//we have a save location value use it
		prefString = prefManager.getCharPref("savelocation");
		
   }
   else {
		// Preference is default value so use that
		//No save location use desktop
		// Get Desktop Location
		var file = Components.classes["@mozilla.org/file/directory_service;1"].
                     getService(Components.interfaces.nsIProperties).
                     get("Desk", Components.interfaces.nsIFile);		
		prefString = file.path ;
   }
//
   
savedir = prefString;

// NOTE: "file" is an object that implements nsIFile. If you want the
// file system path, use file.path
 
 switch(e.target.text)
{
case 'FLV':
  var dl_ext = '.flv';
  break;
  
case '3GP':
  var dl_ext = '.3gp';
  break;
  
case 'MP4':
  var dl_ext = '.mp4';
  break;
  
case 'HD':
  var dl_ext = '.mp4';
  break; 

case 'Full-HD':
  var dl_ext = '.mp4';
  break; 
  
default:
  break;
}


   var uri_path = e.target.href ;
   
   var theOS = getOS();
   var file_path = "";
   
    switch (theOS) 
    {
        case 'win':
        {
	        file_path = savedir + '\\' + vtitle + dl_ext ;
	        break;
        }

        case 'mac':
        {
            file_path = savedir + "//" + vtitle + dl_ext ;
            break; 
        }

        case 'lin':
        {
	        file_path = savedir + "//" + vtitle + dl_ext ;
	        break;
        }
    }


   //var file_path = savedir + '\\' + vtitle + dl_ext
   
   
  var file = Components.classes["@mozilla.org/file/local;1"]
            .createInstance(Components.interfaces.nsILocalFile);
file.initWithPath(file_path);



//Check if file exists
if (file.exists())
	{
		
		//File already exists auto-rename by appending a random number
		var tstamp = new Date().getTime();
		
		
		
		switch (theOS) 
		{
        case 'win':
        {
			file_path = savedir + '\\' + vtitle + '_' + tstamp + dl_ext ;			
	        break;
        }

        case 'mac':
        {
            file_path = savedir + "//" + vtitle + '_' + tstamp + dl_ext ;
            break; 
        }

        case 'lin':
        {
	        file_path = savedir + "//" + vtitle + '_' + tstamp + dl_ext ;
	        break;
        }
		
		
		}
		
		//re-assign the name
		file.initWithPath(file_path);		
		
	}   
	
	

var wbp = Components.classes['@mozilla.org/embedding/browser/nsWebBrowserPersist;1']
          .createInstance(Components.interfaces.nsIWebBrowserPersist);
var ios = Components.classes['@mozilla.org/network/io-service;1']
          .getService(Components.interfaces.nsIIOService);
var uri = ios.newURI(uri_path, null, null);
wbp.persistFlags &= ~Components.interfaces.nsIWebBrowserPersist.PERSIST_FLAGS_NO_CONVERSION; // don't save gzipped

var source = ios.newURI(uri_path, "UTF8", null);
var target = ios.newFileURI(file)

// Save the file silently without displaying dialog box
var xfer = Components.classes["@mozilla.org/transfer;1"]
                       .createInstance(Components.interfaces.nsITransfer);
xfer.init(source, target, "", null, null, null, wbp);
wbp.progressListener = xfer;
  
wbp.saveURI(uri, null, null, null, null, file);
}
document.addEventListener("EasyYoutubeLinkEvent", myLinkListener, false, true);

// -- getOS()
function getOS()
{
  var retVal = '';
  if (typeof(window.navigator.platform) != 'undefined') 
  {
    var platform = window.navigator.platform.toLowerCase();
    if (platform.indexOf('win') != -1)
      retVal = 'win';

    else if (platform.indexOf('mac') != -1)
      retVal = 'mac';

    else if (platform.indexOf('linux') != -1)
      retVal = 'lin';
  }
  return retVal;
}
